#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "tsync.h"
#include "tsync_example.h"

#include "spec_ktsal_en.h"

int main (int argc, char *argv[])
{
    if (argc != 6) {
        printf(" Usage: SW_SetIOSwitch <device> <feature> <type> <io> <instance>\n");
        return EXIT_FAILURE;
    }
    
    int devId = atoi(argv[1]);

    uint8_t feature  = strtol(argv[2], NULL, 16);
    uint8_t type     = strtol(argv[3], NULL, 16);
    uint8_t io       = strtol(argv[4], NULL, 16);
    uint8_t instance = strtol(argv[5], NULL, 16);


    char deviceName[32] = {0};
    sprintf(deviceName, "/dev/tsyncpci%d", devId);
    
    TSYNC_BoardHandle pHandle;
    
    if (TSYNC_open(&pHandle, deviceName) != TSYNC_SUCCESS ) {
        printf("%s: Could not open <%s>\n", argv[0], deviceName);
        return EXIT_FAILURE;
    }

    TSYNC_ERROR err = TSYNC_SW_setIOSwitch(pHandle, feature, type, io, instance);

    if (err != TSYNC_SUCCESS) {
        printf("  Error: %s.\n", tsync_strerror(err));
        return EXIT_FAILURE;
    }
    return EXIT_SUCCESS;
}